#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "dictproxy4xi.py">
#<abstract4xi abstract = "provides types DictProxy and DictProxy4Xi"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------



# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'DictProxy4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref
    import array
    import queue
    from traceback import format_exc         
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import DictProxy
except:
    print("dictproxy4xi.py *** failed in from multiprocessing.managers import DictProxy ***")
#"
#/>
 
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from baseproxy4xi import BaseProxy4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "MakeProxyType4Xi" usage = "
# embedded inside this module so that forkingpickler4xi detects this to be the module
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def MakeProxyType4Xi(name, exposed, cache={}):
    '''
    MakeProxyType4Xi function: returns an proxy type whose methods are given by `exposed`;
    
    '''
    class2print = "MakeProxyType4Xi"
    method2print = "MakeProxyType4Xi"
    
    message2print = "{started" + "; MakeProxyType4Xi-started: " + str(MakeProxyType4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    message2print = "{passed" + "; name-passed-to-MakeProxyType4Xi: " + str(name) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{passed" + "; exposed-passed-to-MakeProxyType4Xi: " + str(exposed) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{passed" + "; cache-passed-to-MakeProxyType4Xi: " + str(cache) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
             
     
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    exposed2xi = tuple(exposed)
    
    message2print = "{set; exposed2xi to: " + str(exposed2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
        
    try:
        message2print = "{returning; cache: " + str(cache[(name, exposed2xi)]) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        return cache[(name, exposed2xi)]
    except KeyError:
        message2print = "{hit; KeyError-name: " + str(name) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        message2print = "{hit; KeyError-exposed: " + str(exposed2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                     
        pass

    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    dic2xi = {}
    message2print = "{starting; loop: calling exec; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    for meth2xi in exposed2xi:
        exec('''def %s(self, *args, **kwds):
        return self._callmethod(%r, args, kwds)''' % (meth2xi, meth2xi), dic2xi)

    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
   
    ProxyType2Xi = type(name, (BaseProxy4Xi,), dic2xi)
    message2print = "{set; ProxyType2Xi to: " + str(ProxyType2Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    
    ProxyType2Xi._exposed_ = exposed2xi

    message2print = "{set; ProxyType2Xi-exposed_to: " + str(ProxyType2Xi._exposed_)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
        
    cache[(name, exposed2xi)] = ProxyType2Xi
    
    message2print = "{set; cache: " + str(cache[(name, exposed2xi)])  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{returning" + "; ProxyType2Xi: " + str(ProxyType2Xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
    
    return ProxyType2Xi
#</function4xi> 

 


# -------------------------------------------------------------------------------------------------
# Types                              
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
#
#<type4xi type = "
DictProxy4Xi = MakeProxyType4Xi('DictProxy4Xi', (
    '__contains__', '__delitem__', '__getitem__', '__len__',
    '__setitem__', 'clear', 'copy', 'get', 'has_key', 'items',
    'keys', 'pop', 'popitem', 'setdefault', 'update', 'values',
    'sense', 'reason', 'ace'))
#"

#usage = "
#     managers.py
#         SyncManager.register('dict', dict, DictProxy)
#     syncmanager4xi.py:
#         SyncManager4Xi.register('dict', dict, DictProxy4Xi)
#"
#>
#</type4xi>

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#
#<record4xi record = "
#
#   test_proxy_mp_xi4.py.txt
#   sense-proxy-mp-test4xi.xml
#   reason-proxy-mp-test4xi.xml
#   ace-proxy-mp-test4xi.xml
#"
#>
  
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of dictproxy4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
